diff --git a/core/arch/arch.c b/core/arch/arch.c
index 4c67e9c58d..bfffcfcb1d 100644
--- a/core/arch/arch.c
+++ b/core/arch/arch.c
@@ -278,7 +278,7 @@ check_size_and_cache_line(dr_isa_mode_t isa_mode, generated_code_t *code, byte *
     byte *next_pc = move_to_start_of_cache_line(isa_mode, pc);
     if ((byte *)ALIGN_FORWARD(pc, PAGE_SIZE) + PAGE_SIZE > code->commit_end_pc) {
         ASSERT(code->commit_end_pc + PAGE_SIZE <= ((byte *)code) + GENCODE_RESERVE_SIZE);
-        heap_mmap_extend_commitment(code->commit_end_pc, PAGE_SIZE);
+        heap_mmap_extend_commitment(code->commit_end_pc, PAGE_SIZE, VMM_SPECIAL_MMAP);
         code->commit_end_pc += PAGE_SIZE;
     }
     return next_pc;
@@ -296,7 +296,8 @@ release_final_page(generated_code_t *code)
     ASSERT(ALIGNED(code->commit_end_pc, PAGE_SIZE));
     ASSERT(ALIGNED(leftover, PAGE_SIZE));
     if (leftover > 0) {
-        heap_mmap_retract_commitment(code->commit_end_pc - leftover, leftover);
+        heap_mmap_retract_commitment(code->commit_end_pc - leftover, leftover,
+                                     VMM_SPECIAL_MMAP);
         code->commit_end_pc -= leftover;
     }
     LOG(THREAD_GET, LOG_EMIT, 1,
@@ -491,7 +492,8 @@ shared_gencode_init(IF_X86_64_ELSE(gencode_mode_t gencode_mode, void))
     bool x86_to_x64_mode = false;
 #endif
 
-    gencode = heap_mmap_reserve(GENCODE_RESERVE_SIZE, GENCODE_COMMIT_SIZE);
+    gencode = heap_mmap_reserve(GENCODE_RESERVE_SIZE, GENCODE_COMMIT_SIZE,
+                                VMM_SPECIAL_MMAP);
     /* we would return gencode and let caller assign, but emit routines
      * that this routine calls query the shared vars so we set here
      */
@@ -869,13 +871,13 @@ arch_exit(IF_WINDOWS_ELSE_NP(bool detach_stacked_callbacks, void))
 #endif
     /* on x64 we have syscall routines in the shared code so can't free if detaching */
     if (IF_WINDOWS(IF_X64(!detach_stacked_callbacks &&)) shared_code != NULL) {
-        heap_munmap(shared_code, GENCODE_RESERVE_SIZE);
+        heap_munmap(shared_code, GENCODE_RESERVE_SIZE, VMM_SPECIAL_MMAP);
     }
 #if defined(X86) && defined(X64)
     if (shared_code_x86 != NULL)
-        heap_munmap(shared_code_x86, GENCODE_RESERVE_SIZE);
+        heap_munmap(shared_code_x86, GENCODE_RESERVE_SIZE, VMM_SPECIAL_MMAP);
     if (shared_code_x86_to_x64 != NULL)
-        heap_munmap(shared_code_x86_to_x64, GENCODE_RESERVE_SIZE);
+        heap_munmap(shared_code_x86_to_x64, GENCODE_RESERVE_SIZE, VMM_SPECIAL_MMAP);
 #endif
     interp_exit();
     mangle_exit();
@@ -1178,8 +1180,8 @@ arch_thread_init(dcontext_t *dcontext)
      */
     ASSERT(GENCODE_COMMIT_SIZE < GENCODE_RESERVE_SIZE);
     /* case 9474; share allocation unit w/ thread-private stack */
-    code = heap_mmap_reserve_post_stack(dcontext,
-                                        GENCODE_RESERVE_SIZE, GENCODE_COMMIT_SIZE);
+    code = heap_mmap_reserve_post_stack(dcontext, GENCODE_RESERVE_SIZE,
+                                        GENCODE_COMMIT_SIZE, VMM_SPECIAL_MMAP);
     ASSERT(code != NULL);
     /* FIXME case 6493: if we split private from shared, remove this
      * memset since we will no longer have a bunch of fields we don't use
@@ -1394,7 +1396,8 @@ arch_thread_exit(dcontext_t *dcontext _IF_WINDOWS(bool detach_stacked_callbacks)
 #ifdef WINDOWS
     if (!detach_stacked_callbacks)
 #endif
-        heap_munmap_post_stack(dcontext, dcontext->private_code, GENCODE_RESERVE_SIZE);
+        heap_munmap_post_stack(dcontext, dcontext->private_code, GENCODE_RESERVE_SIZE,
+                               VMM_SPECIAL_MMAP);
 }
 
 #ifdef WINDOWS
diff --git a/core/fcache.c b/core/fcache.c
index cd3d3d68e0..65ffa9b489 100644
--- a/core/fcache.c
+++ b/core/fcache.c
@@ -952,7 +952,7 @@ fcache_really_free_unit(fcache_unit_t *u, bool on_dead_list, bool dealloc_unit)
      */
     vmvector_remove(fcache_unit_areas, u->start_pc, u->reserved_end_pc);
     if (dealloc_unit)
-        heap_munmap((void*)u->start_pc, UNIT_RESERVED_SIZE(u));
+        heap_munmap((void*)u->start_pc, UNIT_RESERVED_SIZE(u), VMM_CACHE);
     /* always dealloc the metadata */
     nonpersistent_heap_free(GLOBAL_DCONTEXT, u, sizeof(fcache_unit_t)
                             HEAPACCT(ACCT_MEM_MGT));
@@ -1322,7 +1322,7 @@ fcache_create_unit(dcontext_t *dcontext, fcache_t *cache, cache_pc pc, size_t si
             /* allocate new unit */
             commit_size = DYNAMO_OPTION(cache_commit_increment);
             ASSERT(commit_size <= size);
-            u->start_pc = (cache_pc) heap_mmap_reserve(size, commit_size);
+            u->start_pc = (cache_pc) heap_mmap_reserve(size, commit_size, VMM_CACHE);
         }
         ASSERT(u->start_pc != NULL);
         ASSERT(proc_is_cache_aligned((void *)u->start_pc));
@@ -1844,7 +1844,7 @@ cache_extend_commitment(fcache_unit_t *unit, size_t commit_size)
 {
     ASSERT(unit != NULL);
     ASSERT(ALIGNED(commit_size, DYNAMO_OPTION(cache_commit_increment)));
-    heap_mmap_extend_commitment(unit->end_pc, commit_size);
+    heap_mmap_extend_commitment(unit->end_pc, commit_size, VMM_CACHE);
     unit->end_pc += commit_size;
     unit->size += commit_size;
     unit->cache->size += commit_size;
@@ -1981,7 +1981,7 @@ fcache_increase_size(dcontext_t *dcontext, fcache_t *cache, fcache_unit_t *unit,
         ASSERT(commit_size >= slot_size);
         commit_size += unit->size;
         ASSERT(commit_size <= new_size);
-        new_memory = (cache_pc) heap_mmap_reserve(new_size, commit_size);
+        new_memory = (cache_pc) heap_mmap_reserve(new_size, commit_size, VMM_CACHE);
         STATS_FCACHE_SUB(cache, capacity, unit->size);
         STATS_FCACHE_ADD(cache, capacity, commit_size);
         STATS_FCACHE_MAX(cache, capacity_peak, capacity);
@@ -2152,7 +2152,7 @@ fcache_thread_reset_free(dcontext_t *dcontext)
          */
         vmvector_remove(fcache_unit_areas, tu->pending_unmap_pc,
                         tu->pending_unmap_pc+tu->pending_unmap_size);
-        heap_munmap(tu->pending_unmap_pc, tu->pending_unmap_size);
+        heap_munmap(tu->pending_unmap_pc, tu->pending_unmap_size, VMM_CACHE);
         tu->pending_unmap_pc = NULL;
     }
     if (tu->bb != NULL) {
@@ -3605,7 +3605,7 @@ fcache_add_fragment(dcontext_t *dcontext, fragment_t *f)
         vmvector_remove(fcache_unit_areas, tu->pending_unmap_pc,
                         tu->pending_unmap_pc+tu->pending_unmap_size);
         /* caller must dec stats since here we don't know type of cache */
-        heap_munmap(tu->pending_unmap_pc, tu->pending_unmap_size);
+        heap_munmap(tu->pending_unmap_pc, tu->pending_unmap_size, VMM_CACHE);
         tu->pending_unmap_pc = NULL;
     }
 
diff --git a/core/heap.c b/core/heap.c
index d0c27596e5..a70cebdc1d 100644
--- a/core/heap.c
+++ b/core/heap.c
@@ -540,9 +540,9 @@ static void *common_heap_alloc(thread_units_t *tu, size_t size
                                HEAPACCT(which_heap_t which));
 static bool common_heap_free(thread_units_t *tu, void *p, size_t size
                              HEAPACCT(which_heap_t which));
-static void release_real_memory(void *p, size_t size, bool remove_vm);
+static void release_real_memory(void *p, size_t size, bool remove_vm, which_vmm_t which);
 static void release_guarded_real_memory(vm_addr_t p, size_t size, bool remove_vm,
-                                        bool guarded);
+                                        bool guarded, which_vmm_t which);
 
 typedef enum {
     /* I - Init, Interop - first allocation failed
@@ -1010,6 +1010,35 @@ rel32_reachable_from_vmcode(byte *tgt)
 #endif
 }
 
+static inline void
+vmm_update_block_stats(which_vmm_t which, uint num_blocks, bool add)
+{
+    /* XXX: find some way to make a stats array */
+    if (add) {
+        if (which == VMM_HEAP)
+            RSTATS_ADD_PEAK(vmm_blocks_heap, num_blocks);
+        else if (which == VMM_CACHE)
+            RSTATS_ADD_PEAK(vmm_blocks_cache, num_blocks);
+        else if (which == VMM_STACK)
+            RSTATS_ADD_PEAK(vmm_blocks_stack, num_blocks);
+        else if (which == VMM_SPECIAL_HEAP)
+            RSTATS_ADD_PEAK(vmm_blocks_special_heap, num_blocks);
+        else if (which == VMM_SPECIAL_MMAP)
+            RSTATS_ADD_PEAK(vmm_blocks_special_mmap, num_blocks);
+    } else {
+        if (which == VMM_HEAP)
+            RSTATS_SUB(vmm_blocks_heap, num_blocks);
+        else if (which == VMM_CACHE)
+            RSTATS_SUB(vmm_blocks_cache, num_blocks);
+        else if (which == VMM_STACK)
+            RSTATS_SUB(vmm_blocks_stack, num_blocks);
+        else if (which == VMM_SPECIAL_HEAP)
+            RSTATS_SUB(vmm_blocks_special_heap, num_blocks);
+        else if (which == VMM_SPECIAL_MMAP)
+            RSTATS_SUB(vmm_blocks_special_mmap, num_blocks);
+    }
+}
+
 /* Reservations here are done with DYNAMO_OPTION(vmm_block_size) alignment
  * (e.g. 64KB) but the caller is not forced to request at that
  * alignment.  We explicitly synchronize reservations and decommits
@@ -1019,7 +1048,7 @@ rel32_reachable_from_vmcode(byte *tgt)
  * the request.
  */
 static vm_addr_t
-vmm_heap_reserve_blocks(vm_heap_t *vmh, size_t size_in)
+vmm_heap_reserve_blocks(vm_heap_t *vmh, size_t size_in, which_vmm_t which)
 {
     vm_addr_t p;
     uint request;
@@ -1050,6 +1079,7 @@ vmm_heap_reserve_blocks(vm_heap_t *vmh, size_t size_in)
         RSTATS_ADD_PEAK(vmm_vsize_used, size);
         STATS_ADD_PEAK(vmm_vsize_blocks_used, request);
         STATS_ADD_PEAK(vmm_vsize_wasted, size - size_in);
+        vmm_update_block_stats(which, request, true/*add*/);
         DOSTATS({
             if (request > 1) {
                 STATS_INC(vmm_multi_block_allocs);
@@ -1069,7 +1099,7 @@ vmm_heap_reserve_blocks(vm_heap_t *vmh, size_t size_in)
  * Update bookkeeping information about the freed region.
  */
 static void
-vmm_heap_free_blocks(vm_heap_t *vmh, vm_addr_t p, size_t size_in)
+vmm_heap_free_blocks(vm_heap_t *vmh, vm_addr_t p, size_t size_in, which_vmm_t which)
 {
     uint first_block = vmm_addr_to_block(vmh, p);
     uint request;
@@ -1090,6 +1120,7 @@ vmm_heap_free_blocks(vm_heap_t *vmh, vm_addr_t p, size_t size_in)
     ASSERT(vmh->num_free_blocks <= vmh->num_blocks);
     RSTATS_SUB(vmm_vsize_used, size);
     STATS_SUB(vmm_vsize_blocks_used, request);
+    vmm_update_block_stats(which, request, false/*sub*/);
     STATS_SUB(vmm_vsize_wasted, size - size_in);
 }
 
@@ -1114,7 +1145,8 @@ at_reset_at_vmm_limit()
 
 /* Reserve virtual address space without committing swap space for it */
 static vm_addr_t
-vmm_heap_reserve(size_t size, heap_error_code_t *error_code, bool executable)
+vmm_heap_reserve(size_t size, heap_error_code_t *error_code, bool executable,
+                 which_vmm_t which)
 {
     vm_addr_t p;
     /* should only be used on sizable aligned pieces */
@@ -1177,7 +1209,7 @@ vmm_heap_reserve(size_t size, heap_error_code_t *error_code, bool executable)
             }
         }
 
-        p = vmm_heap_reserve_blocks(&heapmgt->vmheap, size);
+        p = vmm_heap_reserve_blocks(&heapmgt->vmheap, size, which);
         LOG(GLOBAL, LOG_HEAP, 2, "vmm_heap_reserve: size=%d p="PFX"\n",
             size, p);
 
@@ -1329,7 +1361,7 @@ END_DATA_SECTION()
  * os_heap_decommit interface can handle this we're OK
  */
 static void
-vmm_heap_free(vm_addr_t p, size_t size, heap_error_code_t *error_code)
+vmm_heap_free(vm_addr_t p, size_t size, heap_error_code_t *error_code, which_vmm_t which)
 {
     LOG(GLOBAL, LOG_HEAP, 2, "vmm_heap_free: size=%d p="PFX" is_reserved=%d\n",
         size, p, vmm_is_reserved_unit(&heapmgt->vmheap, p, size));
@@ -1339,7 +1371,7 @@ vmm_heap_free(vm_addr_t p, size_t size, heap_error_code_t *error_code)
     if (DYNAMO_OPTION(vm_reserve)) {
         if (vmm_is_reserved_unit(&heapmgt->vmheap, p, size)) {
             os_heap_decommit(p, size, error_code);
-            vmm_heap_free_blocks(&heapmgt->vmheap, p, size);
+            vmm_heap_free_blocks(&heapmgt->vmheap, p, size, which);
             LOG(GLOBAL, LOG_HEAP, 2, "vmm_heap_free: freed size=%d p="PFX"\n",
                 size, p);
             return;
@@ -1372,9 +1404,9 @@ vmm_heap_decommit(vm_addr_t p, size_t size, heap_error_code_t *error_code)
  * Returns NULL if fails to allocate memory!
  */
 static void *
-vmm_heap_alloc(size_t size, uint prot, heap_error_code_t *error_code)
+vmm_heap_alloc(size_t size, uint prot, heap_error_code_t *error_code, which_vmm_t which)
 {
-    vm_addr_t p = vmm_heap_reserve(size, error_code, TEST(MEMPROT_EXEC, prot));
+    vm_addr_t p = vmm_heap_reserve(size, error_code, TEST(MEMPROT_EXEC, prot), which);
     if (!p)
         return NULL;               /* out of reserved memory */
 
@@ -1592,7 +1624,7 @@ really_free_unit(heap_unit_t *u)
               (stats_int_t)(UNIT_COMMIT_SIZE(u) - UNIT_RESERVED_SIZE(u)));
     /* remember that u itself is inside unit, not separately allocated */
     release_guarded_real_memory((vm_addr_t)u, UNIT_RESERVED_SIZE(u),
-                                false/*do not update DR areas now*/, true);
+                                false/*do not update DR areas now*/, true, VMM_HEAP);
 }
 
 /* Free all thread-shared state not critical to forward progress;
@@ -1917,7 +1949,8 @@ lockwise_safe_to_allocate_memory()
  * add_vm MUST be false iff this is heap memory, which is updated separately.
  */
 static void *
-get_real_memory(size_t size, uint prot, bool add_vm _IF_DEBUG(const char *comment))
+get_real_memory(size_t size, uint prot, bool add_vm, which_vmm_t which
+                _IF_DEBUG(const char *comment))
 {
     void *p;
     heap_error_code_t error_code;
@@ -1927,7 +1960,7 @@ get_real_memory(size_t size, uint prot, bool add_vm _IF_DEBUG(const char *commen
     /* memory alloc/dealloc and updating DR list must be atomic */
     dynamo_vm_areas_lock(); /* if already hold lock this is a nop */
 
-    p = vmm_heap_alloc(size, prot, &error_code);
+    p = vmm_heap_alloc(size, prot, &error_code, which);
     if (p == NULL) {
         SYSLOG_INTERNAL_WARNING_ONCE("Out of memory -- cannot reserve or "
                                      "commit %dKB.  Trying to recover.", size/1024);
@@ -1944,7 +1977,7 @@ get_real_memory(size_t size, uint prot, bool add_vm _IF_DEBUG(const char *commen
          * impl...should we wait a while and try again if out of memory, hoping
          * other threads have freed some?!?!
          */
-        p = vmm_heap_alloc(size, prot, &error_code);
+        p = vmm_heap_alloc(size, prot, &error_code, which);
         if (p == NULL) {
             report_low_on_memory(OOM_RESERVE, error_code);
         }
@@ -1959,7 +1992,8 @@ get_real_memory(size_t size, uint prot, bool add_vm _IF_DEBUG(const char *commen
 }
 
 static void
-release_memory_and_update_areas(app_pc p, size_t size, bool decommit, bool remove_vm)
+release_memory_and_update_areas(app_pc p, size_t size, bool decommit, bool remove_vm,
+                                which_vmm_t which)
 {
     heap_error_code_t error_code;
     /* these two operations need to be atomic wrt DR area updates */
@@ -1973,19 +2007,19 @@ release_memory_and_update_areas(app_pc p, size_t size, bool decommit, bool remov
     if (decommit)
         vmm_heap_decommit(p, size, &error_code);
     else
-        vmm_heap_free(p, size, &error_code);
+        vmm_heap_free(p, size, &error_code, which);
     ASSERT(error_code == HEAP_ERROR_SUCCESS);
     dynamo_vm_areas_unlock();
 }
 
 /* remove_vm MUST be false iff this is heap memory, which is updated separately */
 static void
-release_real_memory(void *p, size_t size, bool remove_vm)
+release_real_memory(void *p, size_t size, bool remove_vm, which_vmm_t which)
 {
     /* must round up to page sizes for vmm_heap_free */
     size = ALIGN_FORWARD(size, PAGE_SIZE);
 
-    release_memory_and_update_areas((app_pc)p, size, false/*free*/, remove_vm);
+    release_memory_and_update_areas((app_pc)p, size, false/*free*/, remove_vm, which);
 
     /* avoid problem w/ being called by cleanup_and_terminate after dynamo_process_exit */
     if (IF_DEBUG_ELSE(!dynamo_exited_log_and_stats, true))
@@ -1994,7 +2028,7 @@ release_real_memory(void *p, size_t size, bool remove_vm)
 
 static void
 extend_commitment(vm_addr_t p, size_t size, uint prot,
-                  bool initial_commit)
+                  bool initial_commit, which_vmm_t which)
 {
     heap_error_code_t error_code;
     ASSERT(ALIGNED(p, PAGE_SIZE));
@@ -2023,7 +2057,7 @@ extend_commitment(vm_addr_t p, size_t size, uint prot,
  */
 static vm_addr_t
 get_guarded_real_memory(size_t reserve_size, size_t commit_size, uint prot,
-                        bool add_vm, bool guarded, byte *min_addr
+                        bool add_vm, bool guarded, byte *min_addr, which_vmm_t which
                         _IF_DEBUG(const char *comment))
 {
     vm_addr_t p = NULL;
@@ -2033,7 +2067,7 @@ get_guarded_real_memory(size_t reserve_size, size_t commit_size, uint prot,
     ASSERT(reserve_size >= commit_size);
     if (!guarded || !dynamo_options.guard_pages) {
         if (reserve_size == commit_size)
-            return get_real_memory(reserve_size, prot, add_vm _IF_DEBUG(comment));
+            return get_real_memory(reserve_size, prot, add_vm, which _IF_DEBUG(comment));
         guard_size = 0;
     }
 
@@ -2061,12 +2095,12 @@ get_guarded_real_memory(size_t reserve_size, size_t commit_size, uint prot,
 #endif
 
     if (try_vmm)
-        p = vmm_heap_reserve(reserve_size, &error_code, TEST(MEMPROT_EXEC, prot));
+        p = vmm_heap_reserve(reserve_size, &error_code, TEST(MEMPROT_EXEC, prot), which);
 
 #if defined(WINDOWS) && defined(CLIENT_INTERFACE)
     if (!try_vmm || p < (vm_addr_t)min_addr) {
         if (p != NULL)
-            vmm_heap_free(p, reserve_size, &error_code);
+            vmm_heap_free(p, reserve_size, &error_code, which);
         p = os_heap_reserve_in_region
             ((void *)ALIGN_FORWARD(min_addr, PAGE_SIZE),
              (void *)PAGE_START(POINTER_MAX),
@@ -2081,8 +2115,10 @@ get_guarded_real_memory(size_t reserve_size, size_t commit_size, uint prot,
          */
         if (p == NULL) {
             SYSLOG_INTERNAL_WARNING_ONCE("Unable to allocate dstack above app stack");
-            if (!try_vmm)
-                p = vmm_heap_reserve(reserve_size, &error_code, TEST(MEMPROT_EXEC, prot));
+            if (!try_vmm) {
+                p = vmm_heap_reserve(reserve_size, &error_code, TEST(MEMPROT_EXEC, prot),
+                                     which);
+            }
         }
     }
 #endif
@@ -2094,7 +2130,7 @@ get_guarded_real_memory(size_t reserve_size, size_t commit_size, uint prot,
         heap_low_on_memory();
         fcache_low_on_memory();
 
-        p = vmm_heap_reserve(reserve_size, &error_code, TEST(MEMPROT_EXEC, prot));
+        p = vmm_heap_reserve(reserve_size, &error_code, TEST(MEMPROT_EXEC, prot), which);
         if (p == NULL) {
             report_low_on_memory(OOM_RESERVE, error_code);
         }
@@ -2113,7 +2149,7 @@ get_guarded_real_memory(size_t reserve_size, size_t commit_size, uint prot,
     STATS_ADD_PEAK(guard_pages, 2);
 
     p += guard_size;
-    extend_commitment(p, commit_size, prot, true /* initial commit */);
+    extend_commitment(p, commit_size, prot, true /* initial commit */, which);
 
     return p;
 }
@@ -2123,10 +2159,11 @@ get_guarded_real_memory(size_t reserve_size, size_t commit_size, uint prot,
  * which is updated separately.
  */
 static void
-release_guarded_real_memory(vm_addr_t p, size_t size, bool remove_vm, bool guarded)
+release_guarded_real_memory(vm_addr_t p, size_t size, bool remove_vm, bool guarded,
+                            which_vmm_t which)
 {
     if (!guarded || !dynamo_options.guard_pages) {
-        release_real_memory(p, size, remove_vm);
+        release_real_memory(p, size, remove_vm, which);
         return;
     }
 
@@ -2134,7 +2171,7 @@ release_guarded_real_memory(vm_addr_t p, size_t size, bool remove_vm, bool guard
     size += PAGE_SIZE * 2;  /* add top and bottom guards */
     p -= PAGE_SIZE;
 
-    release_memory_and_update_areas((app_pc)p, size, false/*free*/, remove_vm);
+    release_memory_and_update_areas((app_pc)p, size, false/*free*/, remove_vm, which);
 
     /* avoid problem w/ being called by cleanup_and_terminate after dynamo_process_exit */
     if (IF_DEBUG_ELSE(!dynamo_exited_log_and_stats, true)) {
@@ -2148,14 +2185,15 @@ release_guarded_real_memory(vm_addr_t p, size_t size, bool remove_vm, bool guard
  * it's mainly used to allocate our fcache units
  */
 void *
-heap_mmap_ex(size_t reserve_size, size_t commit_size, uint prot, bool guarded)
+heap_mmap_ex(size_t reserve_size, size_t commit_size, uint prot, bool guarded,
+             which_vmm_t which)
 {
     /* XXX i#774: when we split vmheap and vmcode, if MEMPROT_EXEC is requested
      * here (or this is a call from a client, for reachability
      * compatibility), put it in vmcode; else in vmheap.
      */
     void *p = get_guarded_real_memory(reserve_size, commit_size, prot, true, guarded,
-                                      NULL _IF_DEBUG("heap_mmap"));
+                                      NULL, which _IF_DEBUG("heap_mmap"));
 #ifdef DEBUG_MEMORY
     if (TEST(MEMPROT_WRITE, prot))
         memset(p, HEAP_ALLOCATED_BYTE, commit_size);
@@ -2177,21 +2215,21 @@ heap_mmap_ex(size_t reserve_size, size_t commit_size, uint prot, bool guarded)
  * it's mainly used to allocate our fcache units
  */
 void *
-heap_mmap_reserve(size_t reserve_size, size_t commit_size)
+heap_mmap_reserve(size_t reserve_size, size_t commit_size, which_vmm_t which)
 {
     /* heap_mmap always marks as executable */
     return heap_mmap_ex(reserve_size, commit_size,
-                        MEMPROT_EXEC|MEMPROT_READ|MEMPROT_WRITE, true);
+                        MEMPROT_EXEC|MEMPROT_READ|MEMPROT_WRITE, true, which);
 }
 
 /* It is up to the caller to ensure commit_size is a page size multiple,
  * and that it does not extend beyond the initial reservation.
  */
 void
-heap_mmap_extend_commitment(void *p, size_t commit_size)
+heap_mmap_extend_commitment(void *p, size_t commit_size, which_vmm_t which)
 {
     extend_commitment(p, commit_size, MEMPROT_EXEC|MEMPROT_READ|MEMPROT_WRITE,
-                      false /*not initial commit*/);
+                      false /*not initial commit*/, which);
     STATS_SUB(mmap_reserved_only, commit_size);
     STATS_ADD_PEAK(mmap_capacity, commit_size);
 #ifdef DEBUG_MEMORY
@@ -2201,7 +2239,7 @@ heap_mmap_extend_commitment(void *p, size_t commit_size)
 
 /* De-commits from a committed region. */
 void
-heap_mmap_retract_commitment(void *retract_start, size_t decommit_size)
+heap_mmap_retract_commitment(void *retract_start, size_t decommit_size, which_vmm_t which)
 {
     heap_error_code_t error_code;
     ASSERT(ALIGNED(decommit_size, PAGE_SIZE));
@@ -2215,7 +2253,7 @@ heap_mmap_retract_commitment(void *retract_start, size_t decommit_size)
  */
 void *
 heap_mmap_reserve_post_stack(dcontext_t *dcontext,
-                             size_t reserve_size, size_t commit_size)
+                             size_t reserve_size, size_t commit_size, which_vmm_t which)
 {
     void *p;
     byte *stack_reserve_end = NULL;
@@ -2231,7 +2269,7 @@ heap_mmap_reserve_post_stack(dcontext_t *dcontext,
         /* there's not enough room to share the allocation block, stack is too big */
         LOG(GLOBAL, LOG_HEAP, 1, "Not enough room to allocate 0x%08x bytes post stack "
             "of size 0x%08x\n", reserve_size, DYNAMO_OPTION(stack_size));
-        return heap_mmap_reserve(reserve_size, commit_size);
+        return heap_mmap_reserve(reserve_size, commit_size, which);
     }
     if (DYNAMO_OPTION(stack_shares_gencode) &&
         /* FIXME: we could support this w/o vm_reserve, or when beyond
@@ -2280,7 +2318,7 @@ heap_mmap_reserve_post_stack(dcontext_t *dcontext,
             }
         });
         STATS_INC(mmap_no_share_stack_region);
-        return heap_mmap_reserve(reserve_size, commit_size);
+        return heap_mmap_reserve(reserve_size, commit_size, which);
     }
     ASSERT(DYNAMO_OPTION(vm_reserve));
     ASSERT(stack_reserve_end != NULL);
@@ -2305,7 +2343,7 @@ heap_mmap_reserve_post_stack(dcontext_t *dcontext,
                 "heap_mmap_reserve_post_stack: reserve failed "PFX"\n", error_code);
             dynamo_vm_areas_unlock();
             STATS_INC(mmap_no_share_stack_region);
-            return heap_mmap_reserve(reserve_size, commit_size);
+            return heap_mmap_reserve(reserve_size, commit_size, which);
         }
         ASSERT(error_code == HEAP_ERROR_SUCCESS);
     }
@@ -2319,7 +2357,7 @@ heap_mmap_reserve_post_stack(dcontext_t *dcontext,
         }
         dynamo_vm_areas_unlock();
         STATS_INC(mmap_no_share_stack_region);
-        return heap_mmap_reserve(reserve_size, commit_size);
+        return heap_mmap_reserve(reserve_size, commit_size, which);
     }
     account_for_memory(p, reserve_size, prot, true/*add now*/, false
                        _IF_DEBUG("heap_mmap_reserve_post_stack"));
@@ -2342,7 +2380,8 @@ heap_mmap_reserve_post_stack(dcontext_t *dcontext,
  * thread's stack (case 9474).
  */
 void
-heap_munmap_post_stack(dcontext_t *dcontext, void *p, size_t reserve_size)
+heap_munmap_post_stack(dcontext_t *dcontext, void *p, size_t reserve_size,
+                       which_vmm_t which)
 {
     /* We would require a valid dcontext and compare to the stack reserve end,
      * but on detach we have no dcontext, so we instead use block alignment.
@@ -2361,13 +2400,13 @@ heap_munmap_post_stack(dcontext_t *dcontext, void *p, size_t reserve_size)
         !DYNAMO_OPTION(stack_shares_gencode) ||
         (ptr_uint_t)p - GUARD_PAGE_ADJUSTMENT/2 ==
         ALIGN_BACKWARD(p, DYNAMO_OPTION(vmm_block_size))) {
-        heap_munmap(p, reserve_size);
+        heap_munmap(p, reserve_size, which);
     } else {
         /* Detach makes it a pain to pass in the commit size so
          * we use the reserve size, which works fine.
          */
         release_memory_and_update_areas((app_pc)p, reserve_size, true/*decommit*/,
-                                        true/*update now*/);
+                                        true/*update now*/, which);
         LOG(GLOBAL, LOG_HEAP, 2, "heap_munmap_post_stack: %d bytes @ "PFX"\n",
             reserve_size, p);
         STATS_SUB(mmap_capacity, reserve_size);
@@ -2379,21 +2418,21 @@ heap_munmap_post_stack(dcontext_t *dcontext, void *p, size_t reserve_size)
  * it's mainly used to allocate our fcache units
  */
 void *
-heap_mmap(size_t size)
+heap_mmap(size_t size, which_vmm_t which)
 {
-    return heap_mmap_reserve(size, size);
+    return heap_mmap_reserve(size, size, which);
 }
 
 /* free memory-mapped storage */
 void
-heap_munmap_ex(void *p, size_t size, bool guarded)
+heap_munmap_ex(void *p, size_t size, bool guarded, which_vmm_t which)
 {
 #ifdef DEBUG_MEMORY
     /* can't set to HEAP_UNALLOCATED_BYTE since really not in our address
      * space anymore */
 #endif
     release_guarded_real_memory((vm_addr_t)p, size, true/*update DR areas immediately*/,
-                                guarded);
+                                guarded, which);
 
     DOSTATS({
         /* avoid problem w/ being called by cleanup_and_terminate after
@@ -2409,9 +2448,9 @@ heap_munmap_ex(void *p, size_t size, bool guarded)
 
 /* free memory-mapped storage */
 void
-heap_munmap(void *p, size_t size)
+heap_munmap(void *p, size_t size, which_vmm_t which)
 {
-    heap_munmap_ex(p, size, true/*guarded*/);
+    heap_munmap_ex(p, size, true/*guarded*/, which);
 }
 
 #ifdef STACK_GUARD_PAGE
@@ -2432,7 +2471,7 @@ stack_alloc(size_t size, byte *min_addr)
      * hurting us in the common case
      */
     p = get_guarded_real_memory(size, size, MEMPROT_READ|MEMPROT_WRITE, true, true,
-                                min_addr _IF_DEBUG("stack_alloc"));
+                                min_addr, VMM_STACK _IF_DEBUG("stack_alloc"));
 #ifdef DEBUG_MEMORY
     memset(p, HEAP_ALLOCATED_BYTE, size);
 #endif
@@ -2466,7 +2505,7 @@ stack_free(void *p, size_t size)
         size = DYNAMORIO_STACK_SIZE;
     p = (void *) ((vm_addr_t)p - size);
     release_guarded_real_memory((vm_addr_t)p, size, true/*update DR areas immediately*/,
-                                true);
+                                true, VMM_STACK);
     if (IF_DEBUG_ELSE(!dynamo_exited_log_and_stats, true))
         RSTATS_SUB(stack_capacity, size);
 }
@@ -2820,7 +2859,7 @@ heap_create_unit(thread_units_t *tu, size_t size, bool must_be_new)
         ASSERT(commit_size <= size);
         u = (heap_unit_t *)
             get_guarded_real_memory(size, commit_size, MEMPROT_READ|MEMPROT_WRITE,
-                                    false, true, NULL _IF_DEBUG(""));
+                                    false, true, NULL, VMM_HEAP _IF_DEBUG(""));
         new_unit = true;
         /* FIXME: handle low memory conditions by freeing units, + fcache units? */
         ASSERT(u);
@@ -3295,7 +3334,7 @@ common_heap_extend_commitment(heap_pc cur_pc, heap_pc end_pc, heap_pc reserved_e
         }
         ASSERT(!POINTER_OVERFLOW_ON_ADD(end_pc, commit_size) &&
                end_pc + commit_size <= reserved_end_pc);
-        extend_commitment(end_pc, commit_size, prot, false /* extension */);
+        extend_commitment(end_pc, commit_size, prot, false /* extension */, VMM_HEAP);
 #ifdef DEBUG_MEMORY
         memset(end_pc, HEAP_UNALLOCATED_BYTE, commit_size);
 #endif
@@ -4121,9 +4160,9 @@ special_heap_create_unit(special_units_t *su, byte *pc, size_t size, bool unit_f
          * => PR 596808.
          */
         ASSERT(su->top_unit == NULL/*init*/ || su->use_lock);
-        u = (special_heap_unit_t *) get_guarded_real_memory(size, commit_size, prot,
-                                                            true, true, NULL
-                                                            _IF_DEBUG("special_heap"));
+        u = (special_heap_unit_t *)
+            get_guarded_real_memory(size, commit_size, prot, true, true, NULL,
+                                    VMM_SPECIAL_HEAP _IF_DEBUG("special_heap"));
         ASSERT(u != NULL);
         u->alloc_pc = (heap_pc) u;
         /* u is kept at top of unit itself, so displace start pc */
@@ -4404,7 +4443,8 @@ special_heap_exit(void *special)
             /* up to creator to free the heap region */
         } else {
             release_guarded_real_memory((vm_addr_t)u, SPECIAL_UNIT_RESERVED_SIZE(u),
-                                        true/*update DR areas immediately*/, true);
+                                        true/*update DR areas immediately*/, true,
+                                        VMM_SPECIAL_HEAP);
         }
         u = next_u;
     }
@@ -4852,7 +4892,7 @@ alloc_landing_pad(app_pc addr_to_hook)
                      ASSERT(lpad_area->allocated);
                      extend_commitment(lpad_area->commit_end, PAGE_SIZE,
                                        MEMPROT_READ|MEMPROT_EXEC,
-                                       false /* not initial commit */);
+                                       false /* not initial commit */, VMM_SPECIAL_MMAP);
                      lpad_area->commit_end += PAGE_SIZE;
                  }
 
@@ -4931,7 +4971,7 @@ alloc_landing_pad(app_pc addr_to_hook)
          */
         if (allocated) {
             extend_commitment(lpad_area_start, PAGE_SIZE, MEMPROT_READ|MEMPROT_EXEC,
-                              true /* initial commit */);
+                              true /* initial commit */, VMM_SPECIAL_MMAP);
         }
 
         lpad_area = HEAP_TYPE_ALLOC(GLOBAL_DCONTEXT, landing_pad_area_t,
diff --git a/core/heap.h b/core/heap.h
index b632c99782..23d7067f4e 100644
--- a/core/heap.h
+++ b/core/heap.h
@@ -109,6 +109,14 @@ vmcode_get_reachable_region(byte **region_start OUT, byte **region_end OUT);
 #endif
 
 /* virtual heap manager */
+typedef enum {
+    VMM_HEAP = 0,
+    VMM_CACHE,
+    VMM_STACK,
+    VMM_SPECIAL_HEAP,
+    VMM_SPECIAL_MMAP,
+} which_vmm_t;
+
 void vmm_heap_init(void);
 void vmm_heap_exit(void);
 void print_vmm_heap_data(file_t outf);
@@ -145,12 +153,13 @@ void *global_heap_realloc(void *ptr, size_t old_num, size_t new_num,
 bool lockwise_safe_to_allocate_memory(void);
 
 /* use heap_mmap to allocate large chunks of executable memory */
-void *heap_mmap(size_t size);
-void heap_munmap(void *p, size_t size);
-void *heap_mmap_reserve(size_t reserve_size, size_t commit_size);
+void *heap_mmap(size_t size, which_vmm_t which);
+void heap_munmap(void *p, size_t size, which_vmm_t which);
+void *heap_mmap_reserve(size_t reserve_size, size_t commit_size, which_vmm_t which);
 
-void *heap_mmap_ex(size_t reserve_size, size_t commit_size, uint prot, bool guarded);
-void heap_munmap_ex(void *p, size_t size, bool guarded);
+void *heap_mmap_ex(size_t reserve_size, size_t commit_size, uint prot, bool guarded,
+                   which_vmm_t which);
+void heap_munmap_ex(void *p, size_t size, bool guarded, which_vmm_t which);
 
 /* updates dynamo_areas and calls the os_ versions */
 byte *
@@ -164,18 +173,20 @@ unmap_file(byte *map, size_t size);
  */
 void *
 heap_mmap_reserve_post_stack(dcontext_t *dcontext,
-                             size_t reserve_size, size_t commit_size);
+                             size_t reserve_size, size_t commit_size, which_vmm_t which);
 void
-heap_munmap_post_stack(dcontext_t *dcontext, void *p, size_t reserve_size);
+heap_munmap_post_stack(dcontext_t *dcontext, void *p, size_t reserve_size,
+                       which_vmm_t which);
 
 /* It is up to the caller to ensure commit_size is a page size multiple,
  * and that it does not extend beyond the initial reservation.
  */
 void
-heap_mmap_extend_commitment(void *p, size_t commit_size);
+heap_mmap_extend_commitment(void *p, size_t commit_size, which_vmm_t which);
 
 void
-heap_mmap_retract_commitment(void *retract_start, size_t decommit_size);
+heap_mmap_retract_commitment(void *retract_start, size_t decommit_size,
+                             which_vmm_t which);
 
 /* use stack_alloc to build a stack -- it returns TOS */
 void *stack_alloc(size_t size, byte *min_addr);
diff --git a/core/lib/instrument.c b/core/lib/instrument.c
index 76fc812bd4..ac0f9ff2eb 100644
--- a/core/lib/instrument.c
+++ b/core/lib/instrument.c
@@ -2759,14 +2759,14 @@ DR_API
 void *
 dr_nonheap_alloc(size_t size, uint prot)
 {
-    return heap_mmap_ex(size, size, prot, false/*no guard pages*/);
+    return heap_mmap_ex(size, size, prot, false/*no guard pages*/, VMM_SPECIAL_MMAP);
 }
 
 DR_API
 void
 dr_nonheap_free(void *mem, size_t size)
 {
-    heap_munmap_ex(mem, size, false/*no guard pages*/);
+    heap_munmap_ex(mem, size, false/*no guard pages*/, VMM_SPECIAL_MMAP);
 }
 
 static void *
diff --git a/core/lib/statsx.h b/core/lib/statsx.h
index ceec6d3f06..c7ca02ca74 100644
--- a/core/lib/statsx.h
+++ b/core/lib/statsx.h
@@ -977,6 +977,16 @@ under -rstats_to_stderr.
     STATS_DEF("Number of unaligned allocations (TEB's etc.)", unaligned_allocations)
     STATS_DEF("Peak unaligned allocations", peak_unaligned_allocations)
 #endif
+    RSTATS_DEF("Current vmm blocks for heap", vmm_blocks_heap)
+    RSTATS_DEF("Peak vmm blocks for heap", peak_vmm_blocks_heap)
+    RSTATS_DEF("Current vmm blocks for cache", vmm_blocks_cache)
+    RSTATS_DEF("Peak vmm blocks for cache", peak_vmm_blocks_cache)
+    RSTATS_DEF("Current vmm blocks for stack", vmm_blocks_stack)
+    RSTATS_DEF("Peak vmm blocks for stack", peak_vmm_blocks_stack)
+    RSTATS_DEF("Current vmm blocks for special heap", vmm_blocks_special_heap)
+    RSTATS_DEF("Peak vmm blocks for special heap", peak_vmm_blocks_special_heap)
+    RSTATS_DEF("Current vmm blocks for special mmap", vmm_blocks_special_mmap)
+    RSTATS_DEF("Peak vmm blocks for special mmap", peak_vmm_blocks_special_mmap)
     STATS_DEF("Our virtual memory blocks in use", vmm_vsize_blocks_used)
     STATS_DEF("Peak our virtual memory blocks in use", peak_vmm_vsize_blocks_used)
     STATS_DEF("Wasted vmm space due to alignment", vmm_vsize_wasted)
diff --git a/core/perscache.c b/core/perscache.c
index 18a00fe21d..38ff65fbad 100644
--- a/core/perscache.c
+++ b/core/perscache.c
@@ -330,7 +330,7 @@ coarse_unit_reset_free_internal(dcontext_t *dcontext, coarse_info_t *info,
             ASSERT(info->cache_start_pc != NULL);
             ASSERT(info->stubs_start_pc != NULL);
             ASSERT(info->mmap_ro_size == 0);
-            heap_munmap(info->cache_start_pc, info->mmap_size);
+            heap_munmap(info->cache_start_pc, info->mmap_size, VMM_CACHE);
             if (info->has_persist_info) {
                 /* Persisted units point at their mmaps for these structures;
                  * non-persisted dynamically allocate them from DR heap.
@@ -738,7 +738,7 @@ coarse_unit_freeze(dcontext_t *dcontext, coarse_info_t *info, bool in_place)
     /* we need the stubs to start on a new page since will be +rw vs cache +r */
     frozen_cache_size = ALIGN_FORWARD(frozen_cache_size, PAGE_SIZE);
     freeze_info->cache_start_pc =
-        (cache_pc) heap_mmap(frozen_stub_size + frozen_cache_size);
+        (cache_pc) heap_mmap(frozen_stub_size + frozen_cache_size, VMM_CACHE);
     /* FIXME: should show full non-frozen size as well */
     LOG(THREAD, LOG_CACHE, 2,
         "%d frozen stubs @ "SZFMT" bytes + %d fragments @ "SZFMT" bytes => "PFX"\n",
@@ -1931,7 +1931,7 @@ coarse_unit_merge(dcontext_t *dcontext, coarse_info_t *info1, coarse_info_t *inf
     merged->mmap_size = merged_cache_size + stubs1_size + stubs2_size;
     /* Our relative jmps require that we do not exceed 32-bit reachability */
     IF_X64(ASSERT(CHECK_TRUNCATE_TYPE_int(merged->mmap_size)));
-    merged->cache_start_pc = (cache_pc) heap_mmap(merged->mmap_size);
+    merged->cache_start_pc = (cache_pc) heap_mmap(merged->mmap_size, VMM_CACHE);
     merged->cache_end_pc = merged->cache_start_pc + cache1_size + cache2_size;
     merged->stubs_start_pc =
         coarse_stubs_create(merged, merged->cache_start_pc + merged_cache_size,
@@ -2023,7 +2023,7 @@ coarse_unit_merge(dcontext_t *dcontext, coarse_info_t *info1, coarse_info_t *inf
         size_t stubsz = merged->stubs_end_pc - merged->fcache_return_prefix;
         size_t newsz = cachesz_aligned + stubsz;
         size_t old_mapsz = merged->mmap_size;
-        cache_pc newmap = (cache_pc) heap_mmap(newsz);
+        cache_pc newmap = (cache_pc) heap_mmap(newsz, VMM_CACHE);
         ssize_t cache_shift = merged->cache_start_pc - newmap;
         /* stubs have moved too, so a relative shift not absolute */
         ssize_t stubs_shift = cachesz_aligned -
@@ -2035,7 +2035,7 @@ coarse_unit_merge(dcontext_t *dcontext, coarse_info_t *info1, coarse_info_t *inf
             newsz, newmap, newmap + cachesz_aligned, cache_shift, stubs_shift);
         memcpy(newmap, merged->cache_start_pc, cachesz);
         memcpy(newmap + cachesz_aligned, merged->fcache_return_prefix, stubsz);
-        heap_munmap(merged->cache_start_pc, merged->mmap_size);
+        heap_munmap(merged->cache_start_pc, merged->mmap_size, VMM_CACHE);
         coarse_stubs_delete(merged);
         merged->mmap_size = newsz;
         /* Our relative jmps require that we do not exceed 32-bit reachability */
diff --git a/core/unix/loader_android.c b/core/unix/loader_android.c
index d122de3af2..57e5dfa57e 100644
--- a/core/unix/loader_android.c
+++ b/core/unix/loader_android.c
@@ -1,5 +1,5 @@
 /* *******************************************************************************
- * Copyright (c) 2016 Google, Inc.  All rights reserved.
+ * Copyright (c) 2016-2017 Google, Inc.  All rights reserved.
  * *******************************************************************************/
 
 /*
@@ -175,7 +175,8 @@ privload_tls_init(void *app_tls)
             res = init_thread_v6.tls[ANDROID_TLS_SLOT_SELF];
         }
     } else {
-        res = heap_mmap(ALIGN_FORWARD(size_of_pthread_internal(), PAGE_SIZE));
+        res = heap_mmap(ALIGN_FORWARD(size_of_pthread_internal(), PAGE_SIZE),
+                        VMM_SPECIAL_MMAP);
         LOG(GLOBAL, LOG_LOADER, 2, "%s: allocated new TLS at "PFX"; copying from "PFX"\n",
             __FUNCTION__, res, app_tls);
         if (app_tls != NULL)
@@ -215,7 +216,8 @@ privload_tls_exit(void *dr_tp)
     if (dr_tp == NULL || dr_tp == init_thread_v5.tls || dr_tp == init_thread_v6.tls)
         return;
     alloc = (byte *)dr_tp - get_pthread_tls_offs();
-    heap_munmap(alloc, ALIGN_FORWARD(size_of_pthread_internal(), PAGE_SIZE));
+    heap_munmap(alloc, ALIGN_FORWARD(size_of_pthread_internal(), PAGE_SIZE),
+                VMM_SPECIAL_MMAP);
 }
 
 /* For standalone lib usage (i#1862: the Android loader passes
diff --git a/core/unix/loader_linux.c b/core/unix/loader_linux.c
index 073080efec..a0814fd206 100644
--- a/core/unix/loader_linux.c
+++ b/core/unix/loader_linux.c
@@ -1,5 +1,5 @@
 /* *******************************************************************************
- * Copyright (c) 2011-2016 Google, Inc.  All rights reserved.
+ * Copyright (c) 2011-2017 Google, Inc.  All rights reserved.
  * Copyright (c) 2011 Massachusetts Institute of Technology  All rights reserved.
  * *******************************************************************************/
 
@@ -266,7 +266,7 @@ privload_tls_init(void *app_tp)
     /* FIXME: These should be a thread logs, but dcontext is not ready yet. */
     LOG(GLOBAL, LOG_LOADER, 2, "%s: app TLS segment base is "PFX"\n",
         __FUNCTION__, app_tp);
-    dr_tp = heap_mmap(client_tls_alloc_size);
+    dr_tp = heap_mmap(client_tls_alloc_size, VMM_SPECIAL_MMAP);
     ASSERT(APP_LIBC_TLS_SIZE + TLS_PRE_TCB_SIZE + tcb_size <= client_tls_alloc_size);
 #ifdef AARCHXX
     /* GDB reads some pthread members (e.g., pid, tid), so we must make sure
@@ -347,7 +347,7 @@ privload_tls_exit(void *dr_tp)
     if (dr_tp == NULL)
         return;
     dr_tp = dr_tp + tcb_size - client_tls_alloc_size;
-    heap_munmap(dr_tp, client_tls_alloc_size);
+    heap_munmap(dr_tp, client_tls_alloc_size, VMM_SPECIAL_MMAP);
 }
 
 /****************************************************************************
diff --git a/core/unix/os.c b/core/unix/os.c
index 52cac54a69..387592d134 100644
--- a/core/unix/os.c
+++ b/core/unix/os.c
@@ -1947,7 +1947,7 @@ os_tls_init(void)
      * segments need to watch modify_ldt syscall
      */
     /* FIXME: heap_mmap marks as exec, we just want RW */
-    byte *segment = heap_mmap(PAGE_SIZE);
+    byte *segment = heap_mmap(PAGE_SIZE, VMM_SPECIAL_MMAP);
     os_local_state_t *os_tls = (os_local_state_t *) segment;
 
     LOG(GLOBAL, LOG_THREADS, 1, "os_tls_init for thread "TIDFMT"\n", get_thread_id());
@@ -2083,7 +2083,7 @@ os_tls_exit(local_state_t *local_state, bool other_thread)
         os_tls_thread_exit(local_state);
 
     /* We can't free prior to tls_thread_free() in case that routine refs os_tls */
-    heap_munmap(os_tls->self, PAGE_SIZE);
+    heap_munmap(os_tls->self, PAGE_SIZE, VMM_SPECIAL_MMAP);
 #else
     global_heap_free(tls_table, MAX_THREADS*sizeof(tls_slot_t) HEAPACCT(ACCT_OTHER));
     DELETE_LOCK(tls_lock);
diff --git a/core/win32/os.c b/core/win32/os.c
index 9e8e32fc88..282f46c309 100644
--- a/core/win32/os.c
+++ b/core/win32/os.c
@@ -7930,7 +7930,7 @@ detach_handle_callbacks(int num_threads, thread_record_t **threads,
         /* FIXME - this should (along with any do/shared syscall containing gencode) be
          * allocated outside of our vmmheap so that we can free the vmmheap reservation
          * on detach. */
-        byte *callback_buf = (byte *)heap_mmap(callback_buf_size);
+        byte *callback_buf = (byte *)heap_mmap(callback_buf_size, VMM_SPECIAL_MMAP);
         detach_callback_stack_t *per_thread =
             (detach_callback_stack_t *)(callback_buf + DETACH_CALLBACK_CODE_SIZE);
         app_pc *callback_addrs = (app_pc *)(&per_thread[num_threads_with_callbacks]);
